///////////////////////////////////////////////////////////
// BACKGRND.CPP: The basic OWL application.
///////////////////////////////////////////////////////////

#include <owl\pch.h>
#pragma hdrstop
#include "backgrnd.rc"

const int BITMAPW = 24;
const int BITMAPH = 24;

//////////////////////////////////
// The application class.
//////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};

//////////////////////////////////
// The main window class.
//////////////////////////////////
class TWndw : public TFrameWindow
{
public:
	TWndw(TWindow *parent, const char far *title);
	~TWndw();

protected:
	void SetupWindow();
	void CleanupWindow();
	bool EvEraseBkgnd(HDC hDC);
DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1(TWndw, TWindow)
	EV_WM_ERASEBKGND,
// Place response table entries here.
END_RESPONSE_TABLE;

///////////////////////////////////////////////////////////
// TWndw::TWndw()
///////////////////////////////////////////////////////////
TWndw::TWndw(TWindow *parent, const char far *title):
			TFrameWindow(parent, title)
{
	AssignMenu(MENU_1);
	// Perform object initialization here.
}

///////////////////////////////////////////////////////////
// TWndw::~TWndw()
///////////////////////////////////////////////////////////
TWndw::~TWndw()
{
	// Perform object cleanup here.
}

///////////////////////////////////////////////////////////
// TWndw::SetupWindow()
///////////////////////////////////////////////////////////
void TWndw::SetupWindow()
{
	// Call base class's SetupWindow.
	TFrameWindow::SetupWindow();

	// Perform initialization that requires a
	// valid window handle here.
}

bool TWndw::EvEraseBkgnd(HDC hDC)
{
	TBitmap bm(GetApplicationObject()->GetInstance(), BITMAP_1);
	TDC dc(hDC);
	TMemoryDC memdc(dc);
	memdc.SelectObject(bm);

	TRect clientRect = GetClientRect();
	for (int i = 0; i <= (clientRect.Width() / BITMAPW); i++)
		for (int j = 0; j <= (clientRect.Height() / BITMAPH); j++)
			dc.BitBlt(i * BITMAPW, j * BITMAPH, BITMAPW, BITMAPH,
				memdc, 0, 0, SRCCOPY);

/*
	// Get a handle to the application's instance.
	HINSTANCE hInstance = *GetApplication();

	// Construct a bitmap object from the bitmap pattern.
	TBitmap bm(hInstance, BITMAP_1);

	// Construct a DC from the DC handle
	// passed into the function.
	TDC dc(hDC);

	// Create a brush from the bitmap object.
	TBrush brush(bm);

	// Select the brush into the DC.
	dc.SelectObject(brush);

	// Get the size of the window's client area.
	TRect clientRect = GetClientRect();

	// Fill the client area with the pattern.
	dc.PatBlt(clientRect);
*/
	return true;
}


///////////////////////////////////////////////////////////
// TWndw::CleanupWindow()
///////////////////////////////////////////////////////////
void TWndw::CleanupWindow()
{
	// Perform cleanup that requires a valid
	// window handle here.
}

///////////////////////////////////////////////////////////
// TApp::InitMainWindow()
///////////////////////////////////////////////////////////
void TApp::InitMainWindow()
{
	TFrameWindow *wndw = new TWndw(0, "Background Bitmap");
	SetMainWindow(wndw);
}

///////////////////////////////////////////////////////////
// OwlMain()
///////////////////////////////////////////////////////////
int OwlMain(int, char*[])
{
	return TApp().Run();
}

